/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.statistik.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class StatistikKennzeichenTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final de.ivu.elect.business.statistik.entity.StatistikKennzeichenArt kennzeichen;
    public de.ivu.elect.business.statistik.entity.StatistikKennzeichenArt getKennzeichen(){
      return kennzeichen;
    }
  protected final de.ivu.elect.business.gebietsbaum.entity.GebietTK gebietTK;
    public de.ivu.elect.business.gebietsbaum.entity.GebietTK getGebietTK(){
      return gebietTK;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlTK wahlTK;
    public de.ivu.elect.business.wahl.entity.WahlTK getWahlTK(){
      return wahlTK;
    }

  public StatistikKennzeichenTK(
de.ivu.elect.business.statistik.entity.StatistikKennzeichenArt kennzeichen
,   de.ivu.elect.business.gebietsbaum.entity.GebietTK gebietTK
,   de.ivu.elect.business.wahl.entity.WahlTK wahlTK
  ) {
    super();


      this.kennzeichen = kennzeichen;
        this.gebietTK = gebietTK;
      this.wahlTK = wahlTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((kennzeichen == null) ? 0 : kennzeichen.hashCode());
        
                    result = result + ((gebietTK == null) ? 0 : gebietTK.hashCode());
                    result = result + ((wahlTK == null) ? 0 : wahlTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof StatistikKennzeichenTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        StatistikKennzeichenTK other = (StatistikKennzeichenTK) obj;

                if (kennzeichen == null) {
          if (other.kennzeichen != null) {
            return false;
          }
        } else if (!kennzeichen.equals(other.kennzeichen)) {
          return false;
        }
        
                if (gebietTK == null) {
          if (other.gebietTK != null) {
            return false;
          }
        } else if (!gebietTK.equals(other.gebietTK)) {
          return false;
        }
                if (wahlTK == null) {
          if (other.wahlTK != null) {
            return false;
          }
        } else if (!wahlTK.equals(other.wahlTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return StatistikKennzeichenConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(gebietTK.getAllEntityFieldValues());
    result.addAll(wahlTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(StatistikKennzeichenConstants.MESSAGE_KEY_ENTITY_EINZAHL, StatistikKennzeichenConstants.MESSAGE_KEY_KENNZEICHEN_EINZAHL, kennzeichen));
        
        return result;
      }


            @Override
            public String toString() {
            return "StatistikKennzeichenTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"kennzeichen="+kennzeichen
                                        +", gebietTK="+gebietTK
                            +", wahlTK="+wahlTK
            
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(IMessages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                      + messages.getMessageForMessageKey(StatistikKennzeichenConstants.MESSAGE_KEY_KENNZEICHEN_EINZAHL) + "=" +

                                  messages.lokalisiere(kennzeichen)
                
                                      + ", " +  toStringLokalisiert(gebietTK, messages)
                          + ", " +  toStringLokalisiert(wahlTK, messages)
                                 ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends StatistikKennzeichen> java.util.Map<StatistikKennzeichenTK, E> mappeStatistikKennzeichenNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(StatistikKennzeichen::getStatistikKennzeichenTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<StatistikKennzeichen, StatistikKennzeichenTK> getStatistikKennzeichenToTKFunction() {
                return StatistikKennzeichen::getStatistikKennzeichenTK;
                }

}
